<?php

/**
 * @file
 * Whiteboard theme functions
 *
 */

/**
 * Implementation of hook_theme()
 */
function whiteboard_theme() {
  $page = $existing['page'];
  $page['theme paths'][] = drupal_get_path('module', 'whiteboard');
  return array(
    'page' => $page,
    'whiteboard_board' => array(
      'arguments' => array('form' => 'whiteboard_board_form'),
    ),
    'whiteboard_submit' => array(
      'arguments' => array('form' => 'whiteboard_submit_form'),
    ),
    'whiteboard_meta' => array(
      'arguments' => array('form' => 'whiteboard_meta_form'),
    ),
    'whiteboard_top' => array(
      'arguments' => array('form' => 'whiteboard_top_form'),
    ),
    'whiteboard_color' => array(
      'arguments' => array('form' => 'whiteboard_color_form'),
    ),
    'whiteboard_status' => array(
      'arguments' => array('form' => 'whiteboard_status_form'),
    ),
    'whiteboard_side' => array(
      'arguments' => array('form' => 'whiteboard_side_form'),
    ),
    'whiteboard_bottom' => array(
      'arguments' => array('form' => 'whiteboard_bottom_form'),
    ),
    'whiteboard_ellipse' => array(
      'arguments' => array('form' => 'whiteboard_ellipse_form'),
    ),
    'whiteboard_arc' => array(
      'arguments' => array('form' => 'whiteboard_arc_form'),
    ),
    'whiteboard_rectangle' => array(
      'arguments' => array('form' => 'whiteboard_rectangle_form'),
    ),
    'whiteboard_circle' => array(
      'arguments' => array('form' => 'whiteboard_circle_form'),
    ),

  );
}

/**
 * Theme a whiteboard.
 *
 * @ingroup themeable
 */
function theme_whiteboard_board($node) {
  $output .= '<div id="whiteboard-container">';
  $output .= theme('whiteboard_meta', $node);
  $output .= theme('whiteboard_top', $node);
  $output .= '<div id="whiteboard"></div>';
  $output .= theme('whiteboard_side', $node);
  $output .= '<div id="whiteboard-ellipse-container">' . theme('whiteboard_ellipse', $node) . '</div>';
  $output .= '<div id="whiteboard-arc-container">' . theme('whiteboard_arc', $node) . '</div>';
  $output .= '<div id="whiteboard-rectangle-container">' . theme('whiteboard_rectangle', $node) . '</div>';
  $output .= '<div id="whiteboard-circle-container">' . theme('whiteboard_circle', $node) . '</div>';
  $output .= '<div id="whiteboard-color-container">' . theme('whiteboard_color', $node) . '</div>';
  $output .= '<div id="whiteboard-bottom-container">' . theme('whiteboard_bottom', $node) . '</div>';
  $output .= '<div id="whiteboard-status-container"><span id="whiteboard-status"></span></div>';
  $output .= theme('whiteboard_submit', $node); 
  $output .= '</div>';
  return $output;
}

/**
 * Theme whiteboard meta inputs
 *
 * @ingroup themeable
 */
function theme_whiteboard_meta($node) {
  $output = drupal_get_form('whiteboard_meta_form', $node);
  return '<div id="whiteboard-meta">' . $output . '</div>';
}

/**
 * Theme whiteboard side inputs
 *
 * @ingroup themeable
 */
function theme_whiteboard_side($node) {
  $output = drupal_get_form('whiteboard_side_form', $node);
  return '<div id="whiteboard-side">' . $output . '</div>';
}


/**
 * Theme whiteboard top row
 *
 * @ingroup themeable
 */
function theme_whiteboard_top($node) {
  $output = drupal_get_form('whiteboard_top_form', $node);
  return '<div id="whiteboard-top">' . $output . '</div>';
}


/**
 * Theme whiteboard color  buttons.
 *
 * @ingroup themeable
 */
function theme_whiteboard_color($node) {
  $output = drupal_get_form('whiteboard_color_form', $node);
  return '<div id="whiteboard-color">' . $output . '</div>';
}

/**
 * Theme chat buttons.
 *
 * @ingroup themeable
 */
function theme_whiteboard_submit($node) {
  $output = drupal_get_form('whiteboard_submit_form', $node);
  return '<div id="whiteboard-submit-button">' . $output . '</div>';
}

/**
 * Theme whiteboard ellipse inputs
 *
 * @ingroup themeable
 */
function theme_whiteboard_ellipse($node) {
  $output = drupal_get_form('whiteboard_ellipse_form', $node);
  return '<div id="whiteboard-ellipse">' . $output . '</div>';
}

/**
 * Theme whiteboard rectangle inputs
 *
 * @ingroup themeable
 */
function theme_whiteboard_rectangle($node) {
  $output = drupal_get_form('whiteboard_rectangle_form', $node);
  return '<div id="whiteboard-rectangle">' . $output . '</div>';
}

/**
 * Theme whiteboard circle inputs
 *
 * @ingroup themeable
 */
function theme_whiteboard_circle($node) {
  $output = drupal_get_form('whiteboard_circle_form', $node);
  return '<div id="whiteboard-circle">' . $output . '</div>';
}

/**
 * Theme whiteboard arc inputs
 *
 * @ingroup themeable
 */
function theme_whiteboard_arc($node) {
  $output = drupal_get_form('whiteboard_arc_form', $node);
  return '<div id="whiteboard-arc">' . $output . '</div>';
}

/**
 * Theme whiteboard bottom
 *
 * @ingroup themeable
 */
function theme_whiteboard_bottom($node) {
  $output = drupal_get_form('whiteboard_bottom_form', $node);
  return '<div id="whiteboard-bottom">' . $output . '</div>';
}

